import {defHttp} from '/@/utils/http/axios';
import { useMessage } from "/@/hooks/web/useMessage";

const { createConfirm } = useMessage();

enum Api {
  list = '/baosong/baosongTask/list',
  save='/baosong/baosongTask/add',
  edit='/baosong/baosongTask/edit',
  deleteOne = '/baosong/baosongTask/delete',
  deleteBatch = '/baosong/baosongTask/deleteBatch',
  importExcel = '/baosong/baosongTask/importExcel',
  exportXls = '/baosong/baosongTask/exportXls',
  queryAllTasks = '/baosong/baosongTask/queryAllTasks',
  addApproval = '/baosong/baosongTask/addApproval',

  listForFillData = '/baosong/baosongTask/listForFillData',
  importData = '/baosong/baosongTask/importData',
  
}
/**
 * 导出api
 * @param params
 */
export const getExportUrl = Api.exportXls;
/**
 * 导入api
 */
export const getImportUrl = Api.importExcel;
/**
 * 列表接口
 * @param params
 */
export const list = (params) =>
  defHttp.get({url: Api.list, params});

export const listForFillData = (params) =>
  defHttp.get({url: Api.listForFillData, params});


export const queryAllTasks = (params) =>
  defHttp.get({url: Api.queryAllTasks, params});

/**
 * 删除单个
 */
export const deleteOne = (params,handleSuccess) => {
  return defHttp.delete({url: Api.deleteOne, params}, {joinParamsToUrl: true}).then(() => {
    handleSuccess();
  });
}
/**
 * 批量删除
 * @param params
 */
export const batchDelete = (params, handleSuccess) => {
  createConfirm({
    iconType: 'warning',
    title: '确认删除',
    content: '是否删除选中数据',
    okText: '确认',
    cancelText: '取消',
    onOk: () => {
      return defHttp.delete({url: Api.deleteBatch, data: params}, {joinParamsToUrl: true}).then(() => {
        handleSuccess();
      });
    }
  });
}
/**
 * 保存或者更新
 * @param params
 */
export const saveOrUpdate = (params, isUpdate) => {
  let url = isUpdate ? Api.edit : Api.save;
  return defHttp.post({url: url, params});
}


export const addApproval = (params,handleSuccess) => {
  createConfirm({
    iconType: 'warning',
    title: '确认提交审批',
    content: '提交审批',
    okText: '确认',
    cancelText: '取消',
    onOk: () => {
      return defHttp.post({url: Api.addApproval,params}).then(() => {
        handleSuccess();
      });
    }
  });
}



export const importData = (params,handleSuccess) => {
  createConfirm({
    iconType: 'warning',
    title: '将会覆盖当前得数据，确认导入数据吗？',
    content: '导入数据',
    okText: '确认',
    cancelText: '取消',
    onOk: () => {
      return defHttp.get({url: Api.importData,params}).then(() => {
        handleSuccess();
      });
    }
  });
}



